
#ifndef __KEYCOD_HPP
#define __KEYCOD_HPP

enum EDIT_KEYS
{
  K__CTL_A        = 0x1e01,
  K__CTL_B        = 0x3002,
  K__CTL_C        = 0x2e03,
  K__CTL_D        = 0x2004,
  K__CTL_E        = 0x1205,
  K__CTL_F        = 0x2106,
  K__CTL_G        = 0x2207,
  K__CTL_H        = 0x2308,
  K__CTL_I        = 0x1709,
  K__CTL_J        = 0x240a,
  K__CTL_K        = 0x250b,
  K__CTL_L        = 0x260c,
  K__CTL_M        = 0x320d,
  K__CTL_N        = 0x310e,
  K__CTL_O        = 0x180f,
  K__CTL_P        = 0x1910,
  K__CTL_Q        = 0x1011,
  K__CTL_R        = 0x1312,
  K__CTL_S        = 0x1f13,
  K__CTL_T        = 0x1414,
  K__CTL_U        = 0x1615,
  K__CTL_V        = 0x2f16,
  K__CTL_W        = 0x1117,
  K__CTL_X        = 0x2d18,
  K__CTL_Y        = 0x2c19,
  K__CTL_Z        = 0x151a,
  K__CTL_1B       = 0x151b,
  K__CTL_1C       = 0x151c,
  K__CTL_1D       = 0x151d,
  K__CTL_1E       = 0x151e,
  K__CTL_1F       = 0x151f,


  K______A        = 0x1e41,
  K______B        = 0x3042,
  K______C        = 0x2e43,
  K______D        = 0x2044,
  K______E        = 0x1245,
  K______F        = 0x2146,
  K______G        = 0x2247,
  K______H        = 0x2348,
  K______I        = 0x1749,
  K______J        = 0x244a,
  K______K        = 0x254b,
  K______L        = 0x264c,
  K______M        = 0x324d,
  K______N        = 0x314e,
  K______O        = 0x184f,
  K______P        = 0x1950,
  K______Q        = 0x1051,
  K______R        = 0x1352,
  K______S        = 0x1f53,
  K______T        = 0x1454,
  K______U        = 0x1655,
  K______V        = 0x2f56,
  K______W        = 0x1157,
  K______X        = 0x2d58,
  KG_____Y        = 0x2c59,
  KG_____Z        = 0x155a,
  K______a        = 0x1e61,
  K______b        = 0x3062,
  K______c        = 0x2e63,
  K______d        = 0x2064,
  K______e        = 0x1265,
  K______f        = 0x2166,
  K______g        = 0x2267,
  K______h        = 0x2368,
  K______i        = 0x1769,
  K______j        = 0x246a,
  K______k        = 0x256b,
  K______l        = 0x266c,
  K______m        = 0x326d,
  K______n        = 0x316e,
  K______o        = 0x186f,
  K______p        = 0x1970,
  K______q        = 0x1071,
  K______r        = 0x1372,
  K______s        = 0x1f73,
  K______t        = 0x1474,
  K______u        = 0x1675,
  K______v        = 0x2f76,
  K______w        = 0x1177,
  K______x        = 0x2d78,
  KG_____y        = 0x2c79,
  KG_____z        = 0x157a,
  
  K__ALT_60       = 0x003C,
  K__ALT_61       = 0x003D,
  K__ALT_62       = 0x003E,
  K__ALT_63       = 0x003F,
  K__ALT_64       = 0x0040,
  K__ALT_65       = 0x0041,
  K__ALT_66       = 0x0042,
  K__ALT_67       = 0x0043,
  K__ALT_68       = 0x0044,
  K__ALT_69       = 0x0045,
  K__ALT_70       = 0x0046,
  K__ALT_71       = 0x0047,
  K__ALT_72       = 0x0048,
  K__ALT_73       = 0x0049,
  K__ALT_74       = 0x004a,
  K__ALT_75       = 0x004b,
  K__ALT_76       = 0x004c,
  K__ALT_77       = 0x004d,
  K__ALT_78       = 0x004e,
  K__ALT_79       = 0x004f,
  K__ALT_80       = 0x0050,
  K__ALT_81       = 0x0051,
  K__ALT_82       = 0x0052,
  K__ALT_83       = 0x0053,
  K__ALT_84       = 0x0054,
  K__ALT_85       = 0x0055,
  K__ALT_86       = 0x0056,
  K__ALT_87       = 0x0057,
  K__ALT_88       = 0x0058,
  K__ALT_89       = 0x0059,
  K__ALT_90       = 0x005a,
  K__ALT_97       = 0x0061,
  K__ALT_98       = 0x0062,
  K__ALT_99       = 0x0063,
  K__ALT_100      = 0x0064,
  K__ALT_101      = 0x0065,
  K__ALT_102      = 0x0066,
  K__ALT_103      = 0x0067,
  K__ALT_104      = 0x0068,
  K__ALT_105      = 0x0069,
  K__ALT_106      = 0x006a,
  K__ALT_107      = 0x006b,
  K__ALT_108      = 0x006c,
  K__ALT_109      = 0x006d,
  K__ALT_110      = 0x006e,
  K__ALT_111      = 0x006f,
  K__ALT_112      = 0x0070,
  K__ALT_113      = 0x0071,
  K__ALT_114      = 0x0072,
  K__ALT_115      = 0x0073,
  K__ALT_116      = 0x0074,
  K__ALT_117      = 0x0075,
  K__ALT_118      = 0x0076,
  K__ALT_119      = 0x0077,
  K__ALT_120      = 0x0078,
  K__ALT_121      = 0x0079,
  K__ALT_122      = 0x007a,
  K__ALT_123      = 0x007b,
  K__ALT_124      = 0x007c,
  K__ALT_125      = 0x007d,
  K__ALT_126      = 0x007e,
  K__ALT_127      = 0x007f,

  K______1        = 0x0231,
  K______2        = 0x0332,
  K______3        = 0x0433,
  K______4        = 0x0534,
  K______5        = 0x0635,
  K______6        = 0x0736,
  K______7        = 0x0837,
  K______8        = 0x0938,
  K______9        = 0x0a39,
  K______0        = 0x0b30,
  
  K______BSP      = 0x0e08,
  K______ESC      = 0x011b,
  K______BLANK    = 0x3920,
  K______TAB      = 0x0f09, 
  K______ENTER    = 0x1c0d,
  K__CTL_BSP  = 0x0e7f, 

  //Sentence-Delimiter
  K______DOT      = 0x342e,
  K______KOMMA    = 0x332c,
  KG_____SEMI     = 0x333b,
  KG_____COLON    = 0x343a,
  KG_____QUEST    = 0x0c3F,
  K______EXCL     = 0x0221,

  K______EXT_HOME   = 0x47E0,
  K______EXT_CUUP   = 0x48E0,
  K______EXT_PGUP   = 0x49E0,
  K______EXT_CULT   = 0x4bE0,
  K______EXT_CURT   = 0x4dE0,
  K______EXT_END    = 0x4fE0,
  K______EXT_CUDN   = 0x50E0,
  K______EXT_PGDN   = 0x51E0,
  K______EXT_INS    = 0x52E0,
  K______EXT_DEL    = 0x53E0,

  K______NUM_0     = 0x5230,
  K______NUM_9     = 0x4939,
  K______NUM_8     = 0x4838,
  K______NUM_7     = 0x4737,
  K______NUM_6     = 0x4d36,
  K______NUM_5     = 0x4c35,
  K______NUM_4     = 0x4b34,
  K______NUM_3     = 0x5133,
  K______NUM_2     = 0x5032,
  K______NUM_1     = 0x4f31,
  K______NUM_DOT   = 0x532c,

  K______NUM_MINUS  = 0x4a2d,
  K______NUM_PLUS   = 0x4e2b,
  
  K__ALT_ESC  = 0x0100, 
  K__CTL_2    = 0x0300,
  K__CTL_6    = 0x071E,
  K__ALT_BSP  = 0x0E00, 
  K__SHT_TAB  = 0x0F00,

  K__ALT_Q  = 0x1000,
  K__ALT_W  = 0x1100,
  K__ALT_E  = 0x1200,
  K__ALT_R  = 0x1300,
  K__ALT_T  = 0x1400,
  KG_ALT_Y  = 0x1500,
  K__ALT_U  = 0x1600,
  K__ALT_I  = 0x1700,
  K__ALT_O  = 0x1800,
  K__ALT_P  = 0x1900,
  KG_ALT_UE  = 0x1A00,
  KG_ALT_PLUS  = 0x1B00,
  K__ALT_ENTER  = 0x1C00,
  K__ALT_A  = 0x1E00,
  K__ALT_S  = 0x1F00,

  K__ALT_D  = 0x2000,
  K__ALT_F  = 0x2100,
  K__ALT_G  = 0x2200,
  K__ALT_H  = 0x2300,
  K__ALT_J  = 0x2400,
  K__ALT_K  = 0x2500,
  K__ALT_L  = 0x2600,
  KG_ALT_OE  = 0x2700,
  KG_ALT_AE  = 0x2800,
  K__ALT_CIRC  = 0x2900,
  K__ALT_RAUTE  = 0x2B00,
  KG_ALT_Z  = 0x2C00,
  K__ALT_X  = 0x2D00,
  K__ALT_C  = 0x2E00,
  K__ALT_V  = 0x2F00,

  K__ALT_B  = 0x3000,
  K__ALT_N  = 0x3100,
  K__ALT_M  = 0x3200,
  KG_ALT_KOMMA  = 0x3300,
  K__ALT_DOT  = 0x3400,
  KG_ALT_MINUS  = 0x3500,
  K__ALT_STERN  = 0x3700,
  K______F1  = 0x3B00,
  K______F2  = 0x3C00,
  K______F3  = 0x3D00,
  K______F4  = 0x3E00,
  K______F5  = 0x3F00,

  K______F6  = 0x4000,
  K______F7  = 0x4100,
  K______F8  = 0x4200,
  K______F9  = 0x4300,
  K______F10  = 0x4400,
  K______HOME  = 0x4700,
  K______CUUP  = 0x4800,
  K______PGUP  = 0x4900,
  K__ALT_NUM_MINUS = 0x4A00,
  K______CULT  = 0x4B00,
  K______CNTR  = 0x4C00,
  K______CURT  = 0x4D00,
  K__ALT_NUM_PLUS = 0x4E00,
  K______END  = 0x4F00,

  K______CUDN  = 0x5000,
  K______PGDN  = 0x5100,
  K______INS  = 0x5200,
  K______DEL  = 0x5300,
  K__SHT_F1  = 0x5400,
  K__SHT_F2  = 0x5500,
  K__SHT_F3  = 0x5600,
  K__SHT_F4  = 0x5700,
  K__SHT_F5  = 0x5800,
  K__SHT_F6  = 0x5900,
  K__SHT_F7  = 0x5A00,
  K__SHT_F8  = 0x5B00,
  K__SHT_F9  = 0x5C00,
  K__SHT_F10  = 0x5D00,
  K__CTL_F1  = 0x5E00,
  K__CTL_F2  = 0x5F00,

  K__CTL_F3  = 0x6000,
  K__CTL_F4  = 0x6100,
  K__CTL_F5  = 0x6200,
  K__CTL_F6  = 0x6300,
  K__CTL_F7  = 0x6400,
  K__CTL_F8  = 0x6500,
  K__CTL_F9  = 0x6600,
  K__CTL_F10  = 0x6700,
  K__ALT_F1  = 0x6800,
  K__ALT_F2  = 0x6900,
  K__ALT_F3  = 0x6A00,
  K__ALT_F4  = 0x6B00,
  K__ALT_F5  = 0x6C00,
  K__ALT_F6  = 0x6D00,
  K__ALT_F7  = 0x6E00,
  K__ALT_F8  = 0x6F00,

  K__ALT_F9  = 0x7000,
  K__ALT_F10  = 0x7100,
  K__CTL_PTSC  = 0x7200,
  K__CTL_NUM_4  = 0x7300,
  K__CTL_NUM_6  = 0x7400,
  K__CTL_NUM_1  = 0x7500,
  K__CTL_NUM_3  = 0x7600,
  K__CTL_NUM_7  = 0x7700,
  K__ALT_1  = 0x7800,
  K__ALT_2  = 0x7900,
  K__ALT_3  = 0x7A00,
  K__ALT_4  = 0x7B00,
  K__ALT_5  = 0x7C00,
  K__ALT_6  = 0x7D00,
  K__ALT_7  = 0x7E00,
  K__ALT_8  = 0x7F00,

  K__ALT_9  = 0x8000,
  K__ALT_0  = 0x8100,
  KG_ALT_SS = 0x8200,
  KG_ALT_HOCHK = 0x8300,
  K__CTL_NUM_9  = 0x8400,
  K______F11  = 0x8500,
  K______F12  = 0x8600,
  K__SHT_F11  = 0x8700,
  K__SHT_F12  = 0x8800,
  K__CTL_F11  = 0x8900,
  K__CTL_F12  = 0x8A00,
  K__ALT_F11  = 0x8B00,
  K__ALT_F12  = 0x8C00,
  K__CTL_NUM_8  = 0x8D00,
  K__CTL_NUM_MINUS  = 0x8E00,
  K__CTL_NUM_5  = 0x8F00,

  K__CTL_NUM_PLUS  = 0x9000,
  K__CTL_NUM_2  = 0x9100,
  K__CTL_NUM_0  = 0x9200,
  K__CTL_NUM_DOT  = 0x9300,
  K__CTL_TAB  = 0x9400,
  K__CTL_NUM_DIV  = 0x9500,
  K__CTL_MUL  = 0x9600,
  K__ALT_EXT_HOME  = 0x9700,
  K__ALT_EXT_CUUP  = 0x9800,
  K__ALT_EXT_PGUP  = 0x9900,
  K__ALT_EXT_CULT  = 0x9B00,
  K__ALT_EXT_CURT  = 0x9D00,
  K__ALT_EXT_END  = 0x9F00,

  K__ALT_EXT_CUDN  = 0xA000,
  K__ALT_EXT_PGDN  = 0xA100,
  K__ALT_EXT_INS  = 0xA200,
  K__ALT_EXT_DEL  = 0xA300,

  K__ALT_NUM_DIV  = 0xA400,
  K__ALT_TAB  = 0xA500,
  K__ALT_NUM_ENTER  = 0xA600,

  K__CTL_EXT_HOME  = 0x77E0,
  K__CTL_EXT_CUUP  = 0x8DE0,
  K__CTL_EXT_PGUP  = 0x84E0,
  K__CTL_EXT_CULT  = 0x73E0,
  K__CTL_EXT_CURT  = 0x74E0,
  K__CTL_EXT_END   = 0x77E0,
  K__CTL_EXT_CUDN  = 0x91E0,
  K__CTL_EXT_PGDN  = 0x76E0,
  K__CTL_EXT_INS   = 0x92E0,
  K__CTL_EXT_DEL   = 0x93E0,
  
  K__SHT_EXT_HOME  = 0xA700,
  K__SHT_EXT_CUUP  = 0xA800,
  K__SHT_EXT_PGUP  = 0xA900,
  K__SHT_EXT_CULT  = 0xAB00,
  K__SHT_EXT_CURT  = 0xAD00,
  K__SHT_EXT_END  = 0xAF00,
  K__SHT_EXT_CUDN  = 0xB000,
  K__SHT_EXT_PGDN  = 0xB100,
  K__SHT_EXT_INS  = 0xB200,
  K__SHT_EXT_DEL  = 0xB300,

  K______NUM_ENTER = 0xE00D,
  K__SHT_NUM_ENTER = 0xE00D,
  K__CTL_NUM_ENTER = 0xE00A,

  K______NOKEY  = 0xffff
};

#endif


